(function ($) {
    Drupal.behaviors.coolaid = {
        attach: function (context, settings) {
            // Setup.
            $('div.coolaid').not('coolaid-processed').each(function() {
                var $launch = $('<a>').addClass('coolaid-launch').attr('href', '#').attr('title', Drupal.t('Help')).html('?');
                if ($('div.coolaid div.coolaid-message', context).length == 0) {
                    $($launch).addClass('coolaid-add-message').html('+').attr('title', Drupal.t('Add help'));
                }
                $(this).before($launch);

                $(this).data('coolaid_width', $(this).width());
                $(this).data('coolaid_height', $(this).height());
                $(this).hide().addClass('coolaid-processed');

                var sup = $('<div>').addClass('coolaid-sup').html($(this).html()).hide();
                $('body', context).append(sup);

                var close = $('<a>').addClass('coolaid-close').attr('href', '#').attr('title', Drupal.t('Close')).html('&times;');
                $('div.coolaid-sup div.coolaid-content', context).prepend(close);

                var overlay = $('<div>').attr('id', 'coolaid-overlay').fadeTo(0, 0).hide();
                $('body', context).append(overlay);

            });

            // Show overlay.
            $('a.coolaid-launch', context).click(function() {
                var viewportheight = $( window ).height();
                var max_height = viewportheight * 0.8;
                $coolaid = $(this).siblings('.coolaid');
                var coolaid_height = $coolaid.data('coolaid_height');
                var coolaid_width = $coolaid.data('coolaid_width');

                if (coolaid_height < max_height) {
                    max_height = coolaid_height;
                }
                var top_offset = (viewportheight - max_height) / 2;
                $html = $('html');
                $('div.coolaid-sup', context)
                    .css('top', top_offset + 'px')
                    .css('height', max_height + 'px')
                    .css('position', 'absolute')
                    .css('width', coolaid_width + 'px')
                    .css('left', '50%')
                    .css('margin-left', -(coolaid_width / 2));
                $('div#coolaid-overlay', context)
                    .css('width', $html.width())
                    .css('height', $html.height())
                    .show()
                    .fadeTo('fast', 0.66);
                $('div.coolaid-sup', context).show();
            });

            // Hide overlay
            $('div#coolaid-overlay, a.coolaid-close', context).click(function() {
                $('div.coolaid-sup', context).hide();
                $('div#coolaid-overlay', context).fadeTo('slow', 0).hide();
            });

        }
    };
}(jQuery));
